#ifndef PMNS_INTERNAL_H
#define PMNS_INTERNAL_H

#define NCOEFFS_FIELD 10 /* Number of PMNS coeffs */
#define NWORDS_COEFF 1  /* Number of words of one PMNS coeff */
#define PMNS_E 3
/* Upper bound on the coefficient size:
 *    a coeff c is said to be reduced iif c < 2^K
 */
#define PMNS_K 56
#define PMNS_K_mask 0x00ffffffffffffff

#define PMNS_GAMMA 0x000521AE82000000 /* 2^25*3^16 */
#define PMNS_GAMMA_OVER_E 0x0001B5E4D6000000 /* 2^25*3^15 */
#define PMNS_GAMMA_OVER_2E 0x0000DAF26B000000 /* 2^24*3^15 */
#define PMNS_GAMMA2_OVER_E_MOD 0xA8AC000000000000 /* 2^50*5^1*17^1*127^1 */

#define PMNS_SUB_CST0 0x0100941563FFFF6A
#define PMNS_SUB_CST1 0x0100941563FFFFCE
#define PMNS_SUB_CST1P1 0x0100941563FFFFCF
#define PMNS_K_MINUS_EP1 0x00FFFFFFFFFFFFFC

#define PMNS_SUBx2_CST0_0 0x00023D7AA92D8892
#define PMNS_SUBx2_CST0_1 0x001E000000000000
#define PMNS_SUBx2_CST1_0 0xB13ECC5CDB0F2D86
#define PMNS_SUBx2_CST1_1 0x001E00000000000B

#endif /* PMNS_INTERNAL_H */
